<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link rel="icon" href="moose.png">
    <link rel="stylesheet" href="./main.css" type="text/css" />
    <title>eper.io℠ Line Soft Phone</title>
</head>
<!--
Licensed under Creative Commons CC0.
To the extent possible under law, the author(s) have dedicated all copyright
neighboring rights to this software to the public domain worldwide.
This software is distributed without any warranty.
You should have received a copy of the CC0 Public Domain Dedication along wi
If not, see <https:#creativecommons.org/publicdomain/zero/1.0/legalcode>.
-->
<body class="transition-enabled" style="background-color: white; color:#693a26;">
    <div class="container">
        <div class="centered-content">
            <div onclick="navigator.clipboard.writeText(document.location.origin + document.location.pathname + document.location.search + document.location.hash)"><img src="moose.png" alt="moose" style="width: 100px; height: auto;"></div>
            <span class="texteditor-inline-color" style="color:#693a26;" id="peer"><br/>You accept the beta testing <a target="_blank" rel="noopener" href="terms.html">terms</a> by joining<br><br></span>
            <p><br></p>
            <div onclick="call()"><button id="button" class="callbutton" style="background-color: #693a26; color: white;">Call</button></div>
            <p><br></p>
            <embed id='info' type="text/html" src="/news.html" style="height: 3in;width: 3in;">
            <p><br></p>
            <p><a href="/terms.html">Terms</a> • <a href="/documentation.html">Documentation</a> • <a href="/contact.html">Support</a></p>
            <p>eper.io℠ Line Soft Phone</p>
        </div>
    </div>
<script>
    let sampleCountPerSecond = 200000;    // 192 kHz is a typical studio quality frequency We sample 16 bits vs. studio 24.
    let sampleBufferBytes = 256 * 2;    // A buffer of samples. ~1-2ms 128 tends to fill a delay, longer adds glitches and noise.

    // End-to-end encrypted key to
    let leafKey = null
    // End-to-end encrypted key to
    let key = null;
    // The counter block value ensures uniqueness derived from the leaf
    let counter = new Uint8Array(16)
    // document.location.search contains the api key for the server without the e2e leaf key
    let wsHost = "wss://" + document.location.host + "/ws" + document.location.search
    // playback object
    let audioContext = null
    // websocket to read from
    let webSocket = null;
    // loopback flag for testing only
    let loopback = false

    setTimeout(function () {
        document.getElementById('info').src = '/news.html'
    })
    if (document.location.protocol === "http:") {
        wsHost = "ws://" + document.location.host + "/ws" + document.location.search
    }
    if (document.location.search.endsWith('loopback')) {
        sampleBufferBytes = 128 * 2
        loopback = !loopback
    }
    if (loopback) {
        document.getElementById("peer").innerHTML = "loopback mode"
    }

    let a = 0
    setInterval(function () {
        a = 1
    }, 10000)

    if (document.location.search.includes("apikey=") && window.top.location.hash.length > 1 && window.top.location.hash.startsWith("#generate_leaf")) {
        redirectWithLeafName()
    }

    if (document.location.search.includes("apikey=") && window.top.location.hash.length > 1 && window.top.location.hash.startsWith("#leaf_")) {
        leafKey = window.top.location.hash
        for (let i = 0; i < 16; i++) {
            counter[i] = leafKey.slice(-16).charCodeAt(i)
        }
        document.getElementById("peer").innerHTML = "You accept the beta testing <a target=\"_blank\" rel=\"noopener\" href=\"terms.html\">terms</a> by joining.<br>Share the browser link with your peer.<br>"
        document.getElementById("button").innerText = "Join"
    }

    async function redirectWithLeafName() {
        // See create.html for details
        window.crypto.subtle.generateKey(
            {
                name: "AES-CTR",
                length: 256
            },
            true,
            ["encrypt", "decrypt"]
        ).then(async (key) => {
            return await window.crypto.subtle.exportKey("jwk", key)
        }).then((exp) => '#leaf_' + exp.k
        ).then(leaf => {
            let userAgent = navigator.userAgent;
            let downgrade = false

            if (userAgent.indexOf("Chrome") !== -1) {
                // The browser is Google Chrome
                console.log("This is Google Chrome");
            } else if (userAgent.indexOf("Firefox") !== -1) {
                // The browser is Mozilla Firefox
                console.log("This is Mozilla Firefox");
                // They do not support 200 KHz
                downgrade = true
            } else if (userAgent.indexOf("Safari") !== -1) {
                // The browser is Safari
                console.log("This is Safari");
            } else if (userAgent.indexOf("Edge") !== -1) {
                // The browser is Microsoft Edge
                console.log("This is Microsoft Edge");
            } else if (userAgent.indexOf("MSIE") !== -1) {
                // The browser is Internet Explorer
                console.log("This is Internet Explorer");
            } else {
                // The browser is unknown or not one of the above
                console.log("This is an unknown browser");
            }

            window.location.href = document.location.origin + document.location.pathname + document.location.search + leaf
            if (window.innerWidth < window.innerHeight || downgrade) {
                if (document.location.search.indexOf('&mobile=1') === -1) {
                    // Mobile
                    let mobileLink = document.location.origin + document.location.pathname + document.location.search + '&mobile=1' + document.location.hash
                    window.location.href = mobileLink
                        //document.location.origin + document.location.pathname + document.location.search + '&mobile=1' + document.location.hash
                    console.log('switching to mobile bandwidth')
                }
            }
            leafKey = leaf
            for (let i = 0; i < 16; i++) {
                counter[i] = leafKey.slice(-16).charCodeAt(i)
            }
            document.getElementById("button").innerText = "Join"
        })
    }

    async function useKey() {
        import('./e2e.js').then(async _ => {
            if (await testLeafKey()) {
                document.getElementById("peer").innerText = "Joining a call with leaf key."

            } else {
                document.getElementById("peer").innerText = "Invalid leaf key. Copy the leaf key from the peer and Press Join."
            }
        })
    }

    async function testLeafKey() {
        return await import('./e2e.js').then(async (e2e) => {
            let inp = new Int16Array(1024)
            for (let i = 0; i < inp.length; i++) {
                inp[i] = i
            }
            return await e2e.importKey(leafKey)
                .then(async key1 => { key = key1; return await e2e.encrypt(key, counter, inp) })
                .then(async channel => { return await e2e.decrypt(key, counter, channel) })
                .then(async final => {
                    if (final.toString() === inp.toString()) {
                        console.log("Encryption OK.")
                        play()
                        return true
                    } else {
                        console.warn("WARNING Encryption not working: " + inp + "->" + final)
                        key = null
                        return false
                    }
                })
        })
    }

    async function playback(audioBlob) {
        audioBlob.arrayBuffer().then(async aes => {
            if (key == null) {
                console.log('WARNING Unencrypted')
            }
            let arr16 = new Int16Array(aes)
            await window.crypto.subtle.decrypt(
                {
                    name: "AES-CTR",
                    counter,
                    length: 64
                },
                key,
                arr16)
                .then(async (decrypted) => {
                    await audioContext.pcm.port.postMessage({
                        eventType: 'data',
                        audioBuffer: new Int16Array(decrypted)
                    });
                    return decrypted
                }).then(async (filtered) => {
                    if (a > 0) {
                        a = 0
                        let a16 = new Int16Array(filtered)
                        let sum = 0
                        let min = 32767
                        let max = -32768
                        for (let i = 0; i < a16.length; i++) {
                            sum = sum + a16[i].valueOf()
                            if (a16[i].valueOf() > min) {
                                min = a16[i].valueOf()
                            }
                            if (a16[i].valueOf() > max) {
                                max = a16[i].valueOf()
                            }
                        }
                        let avg = sum / a16.length
                        let variance = 0
                        for (let i = 0; i < a16.length; i++) {
                            variance = variance + (a16[i].valueOf() - avg) * (a16[i].valueOf() - avg)
                        }
                        let std = Math.sqrt(variance / a16.length)
                        console.log(min, max, avg, std)
                    }
                }).catch(error => {
                    //console.log("Silence.")
                });
        })
    }

    function call() {
        let action = document.getElementById("button").innerText
        if (action === "Call") {
            document.getElementById("peer").innerHTML = "Connecting..."
        } else if (action === "Join") {
            useKey()
        } else if (action === "Hang Up" && wsHost != null) {
            if (webSocket != null) {
                webSocket.close()
                webSocket = null
            }
            document.location.reload()
        }
    }

    function play() {
        if (audioContext == null) {
            console.log("studio quality sampling:" + sampleCountPerSecond / 1000 + "KHz")
            console.log("audio buffer size:" + sampleBufferBytes * 5 / 1000 + "ms")
            audioContext = new AudioContext({sampleRate: sampleCountPerSecond})
        }

        if (webSocket == null && wsHost != null) {
            webSocket = new WebSocket(wsHost);
            webSocket.binaryType = "blob"
            webSocket.protocol = "chat"
            webSocket.bufferedAmount = 0

            audioContext.audioWorklet.addModule('pcm.js').then(() => {
                audioContext.pcm = new AudioWorkletNode(audioContext, 'pcm_recv');
                audioContext.pcm.connect(audioContext.destination)
            })

            webSocket.onclose = function (/*ws, evt*/) {
                webSocket = null
                if (!document.getElementById("peer").innerHTML.startsWith("Could not connect to websocket.")) {
                    document.getElementById("peer").innerHTML = "connection closed."
                    document.getElementById("button").innerText = "Join"
                }
            }
            webSocket.onmessage = function (evt) {
                if (evt.data instanceof Blob) {
                    playback(evt.data)
                } else {
                    document.getElementById("peer").innerHTML = "websocket buffer not supported.";
                }
            }
            webSocket.onerror = function () {
                webSocket = null
                document.getElementById("peer").innerHTML = "Could not connect to websocket.<br/>Refresh the page and try again."
                document.getElementById("button").innerText = "Join"
            }
            webSocket.onopen = function (/*ws, evt*/) {
                let lnk = document.location.origin + document.location.pathname + document.location.search + document.location.hash
                document.getElementById("peer").innerHTML = "In call.<br/><a href='mailto:@?body="+lnk+"&subject=Please%20Join%20My%20Soft%20Phone%20Line'>📤</a> Share the browser link with the peer<br/>"

                document.getElementById("button").innerText = "Hang Up"

                if (document.location.search.indexOf('mobile=1') === -1) {
                    let mobileLink = document.location.origin + document.location.pathname + document.location.search + '&mobile=1' + document.location.hash
                    document.getElementById("peer").innerHTML = document.getElementById("peer").innerHTML + "<br/>Switch to low bandwidth with <a id=\"mobilelink\" href=\"" + mobileLink + "\">📲</a>"
                }

                console.log("studio quality sampling:" + sampleCountPerSecond / 1000 + "KHz")
                console.log("audio buffer size:" + sampleBufferBytes * 5 / 1000 + "ms")
                navigator.mediaDevices.getUserMedia({audio: {sampleRate: sampleCountPerSecond, echoCancellation: true}}).then(audioStream => {
                    audioContext.audioWorklet.addModule('pcm.js').then(() => {
                        audioContext.socket = webSocket
                        const mic = new MediaStreamAudioSourceNode(audioContext, {mediaStream: audioStream})
                        const pcm = new AudioWorkletNode(audioContext, 'pcm_send');
                        let buf = []
                        pcm.port.onmessage = async function (ev) {
                            let buf0 = ev.data.audioBuffer
                            const len0 = ev.data.audioBuffer.length
                            buf.push(buf0)
                            if (buf.length >= sampleBufferBytes / len0) {
                                const blobSample =  new Blob(buf)
                                buf = []
                                await blobSample.arrayBuffer()
                                    .then(arrBuf => new Int16Array(arrBuf))
                                    .then(arrInp => window.crypto.subtle.encrypt(
                                        {
                                            name: "AES-CTR",
                                            counter,
                                            length: 64
                                        },
                                        key,
                                        arrInp))
                                    .then(ciphertext => {
                                        if (webSocket != null && webSocket.readyState === webSocket.OPEN) {
                                            if (loopback) {
                                                playback(new Blob([ciphertext]))
                                            } else {
                                                webSocket.send(new Blob([ciphertext]))
                                                //console.log(ciphertext)
                                            }
                                        }
                                    }).catch(_ => {
                                        // console.log("Silence.")
                                    });
                            }
                        }
                        mic.connect(pcm)
                    })
                }).catch(()=>{
                    document.getElementById("peer").innerText = "Please connect an audio device and refresh the page."
                    document.getElementById("button").innerText = "Join"
                })
                //bandwidth()
            }
        }
    }

    window.onerror = function (msg, url, line) {
        console.log(msg, url, line)
    }
    function sleep(ms) {
        return new Promise(resolve => setTimeout(resolve, ms));
    }

    setInterval(function () {
        var xmlHttp = new XMLHttpRequest();
        xmlHttp.open( "GET", '/info'+document.location.search, false ); // false for synchronous request
        xmlHttp.onerror = function (msg, url, line) {
            console.log(msg, url)
        }
        xmlHttp.send( null );
        console.log(xmlHttp.responseText);
    }, 5000)
</script>
</body>
</html>